function SetupInput() {
    window.onkeydown = function(e) {
        return !(e.keyCode == 32);
    }
    
    document.addEventListener('keydown', function(event) {Keyboard.OnKeydown(event);});
    document.addEventListener('keyup', function(event) {Keyboard.OnKeyup(event);});
    document.body.onmousedown = function() { 
        ++mouseDown;
        mouseClick = 1;
    }
    document.body.onmouseup = function() {
        --mouseDown;
    }
    
    globalCanvas.addEventListener('mousemove', function(e){ 
        var rect = globalCanvas.getBoundingClientRect();
        mouse.x = e.clientX - rect.left; 
        mouse.y = e.clientY - rect.top;
    }, false);
}

var Keyboard = {
    _pressed: [],

    IsDown: function(keyCode) {
        return this._pressed[keyCode];
    },

    OnKeydown: function(event) {
        this._pressed[event.keyCode] = true;
    },

    OnKeyup: function(event) {
        delete this._pressed[event.keyCode];
    }
};

var Keys = {
    ENTER: 13,
    SHIFT: 16,
    CTRL: 17,
    ALT: 18,
    ESCAPE: 27,
    SPACE: 32,
    
    LEFT: 37,
    UP: 38,
    RIGHT: 39,
    DOWN: 40,
    
    ZERO: 48,
    ONE: 49,
    TWO: 50,
    THREE: 51,
    FOUR: 52,
    FIVE: 53,
    SIX: 54,
    SEVEN: 55,
    EIGHT: 56,
    NINE: 57,
    
    A: 65,
    B: 66,
    C: 67,
    D: 68,
    E: 69,
    F: 70,
    G: 71,
    H: 72,
    I: 73,
    J: 74,
    K: 75,
    L: 76,
    M: 77,
    M: 78,
    O: 79,
    P: 80,
    Q: 81,
    R: 82,
    S: 83,
    T: 84,
    U: 85,
    V: 86,
    W: 87,
    X: 88,
    Y: 89,
    Z: 90,
    
    NUM_ZERO: 96,
    NUM_ONE: 97,
    NUM_TWO: 98,
    NUM_THREE: 99,
    NUM_FOUR: 100,
    NUM_FIVE: 101,
    NUM_SIX: 102,
    NUM_SEVEN: 103,
    NUM_EIGHT: 104,
    NUM_NINE: 105
}

var mouseDown = 0;
var mouseClick = 0;
var mouse = {x: 0, y: 0};