function SetupTextRendering() {
    ctx.font = "12px monospace";
}

function Text(text, fontSize, font) {
    this.text = text;
    this.fontSize = fontSize;
    this.texture = null;
    this.sprite = null;
    this.width = 0;
    this.height = 0;
    this.font = font || "monospace";
    this.GetTexture();
}

Text.prototype.GetTexture = function() {    
    ctx.font = this.fontSize+"px "+this.font;
    var temp = ctx.measureText(this.text);
    tempCanvas.width = temp.width;
    tempCanvas.height = this.fontSize;
    
    this.width = tempCanvas.width;
    this.height = tempCanvas.height;
    
    ctx.clearRect(0, 0, tempCanvas.width, tempCanvas.height);
    ctx.fillStyle = "#ffffff";
    ctx.textAlign = "center";
    ctx.textBaseline = "middle";
    ctx.font = this.fontSize+"px monospace";

    ctx.fillText(this.text, tempCanvas.width/2, tempCanvas.height/2);

    this.texture = new Texture("TempCanvas", true);
    this.sprite = new Sprite(this.texture);
}

Text.prototype.SetText = function(newText, fontSize) {
    this.fontSize = fontSize || this.fontSize;
    this.text = newText;
    this.GetTexture();
}

Text.prototype.Draw = function(x, y) {
    this.sprite.Draw(x + this.width / 2, y + this.height / 2, this.width, this.height);
}

