window.addEventListener('load', EngineMain(document.getElementById("canvas"), Load, Update, Draw), false);

var TOP_SCORE = GetCookie("TopScore");

var frames, fps, timer;
var text, scoreText, currentScoreText;

var score = 0;

var shakeX = 0, shakeY = 0;
var hasStarted = false;
var hasDied = false;

var blockSound = new Sound("blockhit.wav");
var enemySound = new Sound("enemyhit.wav");
var playerSound = new Sound("playerhit.wav");
var music = new Sound("music.ogg");
music.audio.addEventListener('canplay', function() {
        if(!isPlaying) {
        music.SetVolume(0.25);
        music.Loop();
        isPlaying = true;
        playerSound.SetVolume(0.5);
    }
});
var isPlaying = false;

var playerParticles = [];
var playerParticleSprite = new Sprite(null, [1.0, 0.0, 1.0, 1.0]);

var enemyParticles = [];
var enemyParticleSprite = new Sprite(null, [1.0, 0.2, 0.2, 1.0]);

var muteMusicTex = new Sprite(new Texture("https://dl.dropbox.com/s/9ppqyph01avxkpm/MusicTex.png?dl=0"));
var unmuteMusicTex = new Sprite(new Texture("https://dl.dropbox.com/s/wr3f3tp7nsx78lb/MusicTexMuted.png?dl=0"));
var isMusicMuted = false;
var musicRectangle = {
    left: 800-32,
    right: 800,
    top: 600-10-64,
    bottom: 600-10-32
};

var muteSoundTex = new Sprite(new Texture("https://dl.dropbox.com/s/vue8bg7zxq33los/SoundTex.png?dl=0"));
var unmuteSoundTex = new Sprite(new Texture("https://dl.dropbox.com/s/bi73y1fsxmbvtlc/SoundTexMuted.png?dl=0"));
var isSoundMuted = false;
var soundRectangle = {
    left: 800-32,
    right: 800,
    top: 600-5-32,
    bottom: 600-5
};

var comboText;
var comboTimer = 0, comboMaxTimer = 0.5;
var combo = 0;

var comboStrings = [
    "Double kill",
    "Triple kill!",
    "Quadra kill!!",
    "PENTA KILL!!!",
    "Too much! Calm down!",
];

var player = {
    x: 400,
    y: 300,
    size: 32,
    
    isPushing: false,    
    outwards: false,
    pushTimer: 0,
    pushMaxTimer: 0.5,
    pushSize: 0,
    pushMaxSize: 76,
    
    isPulling: false,
    pullSize: 0,
    pullMaxSize: 80,
    pullTimer: 0,
    pullMaxTimer: 1,
    
    pushSprite: new Sprite(null, [0.6, 0.6, 0.6, 0.6]),
    pullSprite: new Sprite(null, [0.6, 0.6, 0.6, 0.6]),
    sprite: new Sprite(null, [1.0, 0.0, 1.0, 1.0])
};

var block = {
    x: 400,
    y: 150,
    velx: 0,
    vely: 0,
    friction: 0.9,
    size: 24,
    sprite: new Sprite(null, [1.0, 0.7, 0.3, 1.0]),
    motionBlur: []
};

var blockBlurSprites = [
    new Sprite(null, [1.0, 0.7, 0.3, 1.0]),
    new Sprite(null, [1.0, 0.7, 0.3, 0.8]),
    new Sprite(null, [1.0, 0.7, 0.3, 0.6]),
    new Sprite(null, [1.0, 0.7, 0.3, 0.4]),
    new Sprite(null, [1.0, 0.7, 0.3, 0.2]),
];

var enemySprite = new Sprite(null, [1.0, 0.2, 0.2, 1.0]);

var enemies = {
    array: []
};

var particles = [];
var particleSprite = new Sprite(null, [0.8, 0.3, 0.3, 1.0]);

var enemyTimer = 0;

function Load() {
    gl.clearColor(1, 1, 0, 1);
    SIMPLE_SHADER = new Shader(BASIC_SHADER_VS, BASIC_SHADER_FS);
	
    text = new Text("temp", 22);    
    currentScoreText = new Text("temp", 22);
    scoreText = new Text("Score:", 36);
    comboText = new Text("null", 36);

    fps = 0;
    frames = 0;
    timer = Date.now();
}

function Update(dt) {
    var mouseRect = {
        left: mouse.x,
        right: mouse.x + 1,
        top: mouse.y,
        bottom: mouse.y + 1
    };
    
    if(Date.now() - timer >= 1000) {
        fps = frames;
        frames = 0;
        timer = Date.now();
        text.SetText(fps + " fps");
    }
    
    enemyTimer += dt;
    if(enemyTimer > Math.max((4 - score / 15), 0.5) && hasStarted) {
        CreateEnemy();
        enemyTimer = 0;
    }

    var xLeft = block.velx;
    var yLeft = block.vely;
    
    while(Math.abs(xLeft) > 0 || Math.abs(yLeft) > 0) {
        if(Math.abs(xLeft) >= 1) {
            block.x += Sign(xLeft);
            xLeft -= Sign(xLeft);
        } else {
            block.x += xLeft;
            xLeft = 0;
        }
        
        if(Math.abs(yLeft) >= 1) {
            block.y += Sign(yLeft);
            yLeft -= Sign(yLeft);
        } else {
            block.y += yLeft;
            yLeft = 0;
        }
        
        BlockEnemyCollision();
    }

    block.velx *= block.friction;
    block.vely *= block.friction;
    
    if(!hasDied) {
        if(Keyboard.IsDown(Keys.W)) player.y -= 5;
        if(Keyboard.IsDown(Keys.A)) player.x -= 5;
        if(Keyboard.IsDown(Keys.S)) player.y += 5;
        if(Keyboard.IsDown(Keys.D)) player.x += 5;
        playerParticles.push({
                    x: player.x,
                    y: player.y,
                    life: 5 + Math.random() * 25,
                    velx: (Math.random() - 0.5) * 1.1,
                    vely: (Math.random() - 0.5) * 1.1,
                    size: Math.random() * 12
        });
    }
    
    player.pushTimer += dt;
    player.pullTimer += dt;
    comboTimer += dt;
    
    if(comboTimer >= comboMaxTimer) {
        combo = 0;
    }
    
    if(Keyboard.IsDown(Keys.SHIFT) && player.isPulling === false && player.pullTimer > player.pullMaxTimer) {
        player.isPulling = true;
        player.pullTimer = 0;
        player.pullSize = player.pullMaxSize;
        block.velx = -(block.x - player.x) / 20;
        block.vely = -(block.y - player.y) / 20;
    }
    
    if(Keyboard.IsDown(Keys.SPACE) && player.isPushing === false && player.pushTimer > player.pushMaxTimer) {
        player.isPushing = true;
        player.outwards = true;
        player.pushTimer = 0;
    }
    
    if(player.isPushing) {
        if(player.outwards) {
            player.pushSize += player.pushMaxSize / (player.pushMaxTimer/6) * dt;
            if(player.pushSize >= player.pushMaxSize) {
                player.outwards = false;
            }
        } else {
            player.pushSize -= player.pushMaxSize / (player.pushMaxTimer/6) * dt;
            if(player.pushSize <= 0) {
                player.pushSize = 0;
                player.isPushing = false;
            }
        }
    }
    
    if(player.isPulling) {
        player.pullSize -= player.pullMaxSize / (player.pullMaxTimer/6) * dt;
        if(player.pullSize <= 0) {
            player.pullSize = 0;
            player.isPulling = false;
        }
    }
    
    if(player.x < player.size/2) player.x = player.size/2;
    if(player.x > 800-player.size/2) player.x = 800-player.size/2;
    if(player.y < player.size/2) player.y = player.size/2;
    if(player.y > 600-player.size/2) player.y = 600-player.size/2;
    
    if(block.x < block.size/2) {
        block.x = block.size/2;
        block.velx = -block.velx;
        if(Math.abs(block.velx) > 6) {
            shakeX += 10;
            shakeY += 10;
            blockSound.Stop();
            blockSound.Play();
        }
    }
    
    if(block.x > 800 - block.size/2) {
        block.x = 800 - block.size/2;
        block.velx = -block.velx;
        if(Math.abs(block.velx) > 6) {
            shakeX += 10;
            shakeY += 10;
            blockSound.Stop();
            blockSound.Play();
        }
    }
    
    if(block.y < block.size/2) {
        block.y = block.size/2;
        block.vely = -block.vely;
        if(Math.abs(block.vely) > 6) {
            shakeX += 10;
            shakeY += 10;
            blockSound.Stop();
            blockSound.Play();
        }
    }
    
    if(block.y > 600 - block.size/2) {
        block.y = 600 - block.size/2;
        block.vely = -block.vely;
        if(Math.abs(block.vely) > 6) {
            shakeX += 10;
            shakeY += 10;
            blockSound.Stop();
            blockSound.Play();
        }
    }
    
    if(player.outwards == true && RectangleCollision({
                              left: player.x - player.pushSize / 2,
                              right: player.x + player.pushSize / 2,
                              top: player.y - player.pushSize / 2,
                              bottom: player.y + player.pushSize / 2
                          }, {
                              left: block.x - block.size / 2,
                              right: block.x + block.size / 2,
                              top: block.y - block.size / 2,
                              bottom: block.y + block.size / 2
                        })) {
        block.velx = (block.x - player.x)*2;
        block.vely = (block.y - player.y)*2;
        shakeX += 50;
        shakeY += 50;
        blockSound.Stop();
        blockSound.Play();
        if(!hasStarted) {
            score = 0;
            currentScoreText.SetText("Score: 0");
            hasStarted = true;
        }
    }
    
    if(RectangleCollision({
                              left: player.x - player.size / 2,
                              right: player.x + player.size / 2,
                              top: player.y - player.size / 2,
                              bottom: player.y + player.size / 2
                          }, {
                              left: block.x - block.size / 2,
                              right: block.x + block.size / 2,
                              top: block.y - block.size / 2,
                              bottom: block.y + block.size / 2
                        })) {
        block.velx += (block.x - player.x)/80;
        block.vely += (block.y - player.y)/80;
    }
    
    for(var i = 0; i < block.motionBlur.length; i++) {
        block.motionBlur[i].age++;
    }
    
    block.motionBlur.push({
        age: 0,
        x: block.x,
        y: block.y
    });
    
    if(block.motionBlur.length > 5) {
        block.motionBlur = block.motionBlur.splice(4, 1);
    }
    
    for(var i = 0; i < enemies.array.length; i++) {
        UpdateAI(enemies.array[i]);
        
        if(enemies.array[i].dead) {
            enemies.array.splice(i, 1);
            continue;
        }
        
        if(!hasDied && RectangleCollision({
                              left: player.x - player.size / 2,
                              right: player.x + player.size / 2,
                              top: player.y - player.size / 2,
                              bottom: player.y + player.size / 2
                          }, {
                              left: enemies.array[i].x - enemies.array[i].size / 2,
                              right: enemies.array[i].x + enemies.array[i].size / 2,
                              top: enemies.array[i].y - enemies.array[i].size / 2,
                              bottom: enemies.array[i].y + enemies.array[i].size / 2
                        })) {
            hasDied = true;
            playerSound.Stop();
            playerSound.Play();
            var numParts = Math.ceil(Math.random() * 100) + 10;
            for(var j = 0; j < numParts; j++) {
                playerParticles.push({
                    x: player.x,
                    y: player.y,
                    life: 10 + Math.random() * 60,
                    velx: (Math.random() - 0.5) * 20,
                    vely: (Math.random() - 0.5) * 20,
                    size: Math.random() * 10
                });
            }
        }
    }
    
    for(var i = 0; i < particles.length; i++) {
        particles[i].life--;
        if(particles[i].life < 0) {
            particles.splice(i, 1);
            continue;
        }
        
        particles[i].x += particles[i].velx;
        particles[i].y += particles[i].vely;
    }
    
    for(var i = 0; i < playerParticles.length; i++) {
        playerParticles[i].life--;
        if(playerParticles[i].life < 0) {
            playerParticles.splice(i, 1);
            continue;
        }
        
        playerParticles[i].x += playerParticles[i].velx;
        playerParticles[i].y += playerParticles[i].vely;
    }
    
    for(var i = 0; i < enemyParticles.length; i++) {
        enemyParticles[i].life--;
        if(enemyParticles[i].life < 0) {
            enemyParticles.splice(i, 1);
            continue;
        }
        
        enemyParticles[i].x += enemyParticles[i].velx;
        enemyParticles[i].y += enemyParticles[i].vely;
    }
    
    if(hasDied && playerParticles.length == 0) {
        if(score > TOP_SCORE) {
            TOP_SCORE = score;
            SetCookie("TopScore", TOP_SCORE, 10000);
        }
        
        enemies.array = [];
        player.x = 400;
        player.y = 300;
        block.x = 400;
        block.y = 150;
        score = 0;
        hasStarted = false;
        hasDied = false;
    }
    
    shakeX *= 0.9;
    shakeY *= 0.9;
    
    if(mouseClick && RectangleCollision(mouseRect, musicRectangle)) {
        isMusicMuted = !isMusicMuted;
        if(isMusicMuted) {
            music.Stop();
        } else {
            music.Loop();
        }
    }
    
    if(mouseClick && RectangleCollision(mouseRect, soundRectangle)) {
        isSoundMuted = !isSoundMuted;
        if(isSoundMuted) {
            playerSound.SetVolume(0);
            enemySound.SetVolume(0);
            blockSound.SetVolume(0);
        } else {
            playerSound.SetVolume(0.5);
            enemySound.SetVolume(1);
            blockSound.SetVolume(1);
        }
    }
    
    mouseClick = 0;
}

function Draw(dt) {
    var sx = (Math.random() - 0.5) * shakeX;
    var sy = (Math.random() - 0.5) * shakeY;

    SpriteSetShader(SIMPLE_SHADER);
    
    if(!hasDied) {
        player.pushSprite.Draw(player.x + sx, player.y + sy, player.pushSize, player.pushSize);
        player.pullSprite.Draw(player.x + sx, player.y + sy, player.pullSize, player.pullSize);
        player.sprite.Draw(player.x + sx, player.y + sy, player.size, player.size, 0);
    }
    
    for(var i = 1; i < block.motionBlur.length; i++) {
        if(block.motionBlur[i].age >= 5) continue;
        var dx = (block.motionBlur[i].x + block.motionBlur[i-1].x) / 2 + sx;        
        var dy = (block.motionBlur[i].y + block.motionBlur[i-1].y) / 2 + sy;

        blockBlurSprites[block.motionBlur[i].age].Draw(dx, dy, block.size, block.size);
        blockBlurSprites[block.motionBlur[i].age].Draw(block.motionBlur[i].x + sx, block.motionBlur[i].y + sy, block.size, block.size);
    }
    
    block.sprite.Draw(block.x + sx, block.y + sy, block.size, block.size);
    
    for(var i = 0; i < enemies.array.length; i++) {
        enemySprite.Draw(enemies.array[i].x + sx, enemies.array[i].y + sy, enemies.array[i].size, enemies.array[i].size);
    }
    
    for(var i = 0; i < particles.length; i++) {
        particleSprite.Draw(particles[i].x, particles[i].y, particles[i].size, particles[i].size);
    }
    
    for(var i = 0; i < playerParticles.length; i++) {
        playerParticleSprite.Draw(playerParticles[i].x, playerParticles[i].y, playerParticles[i].size, playerParticles[i].size);
    }
    
    for(var i = 0; i < enemyParticles.length; i++) {
        enemyParticleSprite.Draw(enemyParticles[i].x, enemyParticles[i].y, enemyParticles[i].size, enemyParticles[i].size);
    }
    
    if(combo > 1) {
        comboText.SetText(comboStrings[combo-2]);
        comboText.Draw(280, 30);
    }
    
    if(!hasStarted) {
        text.SetText("Block pushy zoom-zoom!");
        text.Draw(260, 80);
        text.SetText("Use WASD to move, and the spacebar to push the block.");
        text.Draw(100, 470);
        text.SetText("Use the shift key to pull the block back to you.");
        text.Draw(100, 500);
        text.SetText("Watch out for the red stuff, hit them with the block.");
        text.Draw(100, 530);
        text.SetText("Push the block to start.     Mute stuff ->");
        text.Draw(250, 560);
        text.SetText(fps + " fps");
        
        if(TOP_SCORE != 0) {
            scoreText.SetText("Highscore: " + TOP_SCORE);
            scoreText.Draw(270, 30);
        }
    } else {
        currentScoreText.Draw(330, 5);
    }
    
    if(!isMusicMuted) {
        muteMusicTex.Draw(musicRectangle.left + 16, musicRectangle.top + 16, 32, 32);
    } else {
        unmuteMusicTex.Draw(musicRectangle.left + 16, musicRectangle.top + 16, 32, 32);
    }
    
    if(!isSoundMuted) {
        muteSoundTex.Draw(soundRectangle.left + 16, soundRectangle.top + 16, 32, 32);
    } else {
        unmuteSoundTex.Draw(soundRectangle.left + 16, soundRectangle.top + 16, 32, 32);
    }
    
    text.Draw(5, 5);
    frames++;
}

function RectangleCollision(r1, r2) {
  return !(r2.left > r1.right || 
           r2.right < r1.left || 
           r2.top > r1.bottom ||
           r2.bottom < r1.top);
}

function DistanceTo(x1, y1, x2, y2) {
    return Math.sqrt(Math.pow(x2 - x1, 2) + Math.pow(y2 - y1, 2));
}

function Normalize(x, y) {
    var length = Math.sqrt(x * x + y * y);
    return [x / length, y / length];
}

function Sign(x) { return x ? x < 0 ? -1 : 1 : 0; }

function CreateEnemy() {
    var side = Math.ceil(Math.random() * 4);
    var sx = 0, sy = 0;
    
    if(side == 1) { // LEFT
        sx = -100;
        sy = Math.random() * 600;
    }
    
    if(side == 2) { // RIGHT
        sx = 900;
        sy = Math.random() * 600;
    }
    
    if(side == 3) { // TOP
        sy = -100;
        sy = Math.random() * 800;
    }
    
    if(side == 4) { // BOTTOM
        sy = 700;
        sx = Math.random() * 800;
    }
    //if(!enemies) enemies = [];
    enemies.array.push({
        x: sx,
        y: sy,
        size: 32,
        speed: 2,
        dead: false,
    });
}

function BlockEnemyCollision() {
    for(var i = 0; i < enemies.array.length; i++) {
        var enemy = enemies.array[i]; 
        if(!enemy.dead) {
            if(RectangleCollision({
                                      left: enemy.x - enemy.size / 2,
                                      right: enemy.x + enemy.size / 2,
                                      top: enemy.y - enemy.size / 2,
                                      bottom: enemy.y + enemy.size / 2
                                  }, {
                                      left: block.x - block.size / 2,
                                      right: block.x + block.size / 2,
                                      top: block.y - block.size / 2,
                                      bottom: block.y + block.size / 2
                                })) {
                enemy.dead = true;
                enemySound.Stop();
                enemySound.Play();
                score += combo + 1;
                combo++;
                comboTimer = 0;
                currentScoreText.SetText("Score: " + score);
                
                var numParts = Math.ceil(Math.random() * 10) + 5;
                for(var j = 0; j < numParts; j++) {
                    particles.push({
                        x: enemy.x,
                        y: enemy.y,
                        life: 5 + Math.random() * 30,
                        velx: (Math.random() - 0.5) * 20,
                        vely: (Math.random() - 0.5) * 20,
                        size: Math.random() * 10
                    });
                }
                return;
            }
        }
    }
}

function UpdateAI(enemy) {    
    if(DistanceTo(enemy.x, enemy.y, block.x, block.y) < 40) {
        var direction = Normalize(enemy.x - block.x, enemy.y - block.y);
        enemy.x += direction[0] * enemy.speed;
        enemy.y += direction[1] * enemy.speed;
        return;
    }
    
    var direction = Normalize(enemy.x - player.x, enemy.y - player.y);
    enemy.x -= direction[0] * enemy.speed;
    enemy.y -= direction[1] * enemy.speed;
    
    enemyParticles.push({
            x: enemy.x,
            y: enemy.y,
            life: 5 + Math.random() * 20,
            velx: (Math.random() - 0.5) * 1.1,
            vely: (Math.random() - 0.5) * 1.1,
            size: Math.random() * 12
    });
}

function GetCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for(var i=0; i<ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') c = c.substring(1);
        if (c.indexOf(name) == 0) return (c.substring(name.length,c.length));
    }
    return 0;
}

function SetCookie(cname, cvalue, exdays) {
    var d = new Date();
    d.setTime(d.getTime() + (exdays*24*60*60*1000));
    var expires = "expires="+d.toUTCString();
    document.cookie = cname + "=" + cvalue + "; " + expires + "; path=/";
}